#include <stdio.h> 
#include <stdlib.h>
#include <pthread.h>


pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutex2 = PTHREAD_MUTEX_INITIALIZER;


void *tache1(void *arg)
{
    printf("1 2 3\n");
    pthread_mutex_unlock(&mutex1);
}

void *tache2(void *arg)
{
    pthread_mutex_lock(&mutex1);
    printf("4 5 6\n");
    pthread_mutex_unlock(&mutex2);
    pthread_mutex_unlock(&mutex1);
}

void *tache3(void *arg)
{
    pthread_mutex_lock(&mutex2);
    printf("7 8 9\n");
    pthread_mutex_unlock(&mutex2);
}

int main()
{
    pthread_mutex_lock(&mutex1);
    pthread_mutex_lock(&mutex2);

    pthread_t ligne1, ligne2, ligne3;

    pthread_create(&ligne1, NULL, tache1, (void*)1);
    pthread_create(&ligne2, NULL, tache2, (void*)2);
    pthread_create(&ligne3, NULL, tache3, (void*)3);

    pthread_join(ligne1, NULL);
    pthread_join(ligne2, NULL);
    pthread_join(ligne3, NULL);

    return 0;
}
